package com.ShowParam;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.*;

 
public class WebConfig implements Filter {

    public void init(FilterConfig filterConfig) throws ServletException
    { 
    }
 
    public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) {
      HttpServletResponse response = (HttpServletResponse) res;
      HttpServletRequest request = (HttpServletRequest) req;
      System.out.println("WebConfig Filter; "+request.getRequestURI());
      response.setHeader("Access-Control-Allow-Origin", "https://acad.kutztown.edu");
      response.setHeader("Access-Control-Allow-Credentials", "true");
      response.setHeader("Access-Control-Allow-Methods", "GET,HEAD,OPTIONS,POST,PUT");
      response.setHeader("Access-Control-Allow-Headers", "Access-Control-Allow-Headers, Origin,Accept, X-Requested-With, Content-Type, Access-Control-Request-Method, Access-Control-Request-Headers");
      response.setHeader("Access-Control-Max-Age", "3600");
      response.setHeader("Access-Control-Expose-Headers", "Authorization");
      response.addHeader("Access-Control-Expose-Headers", "responseType");
      response.addHeader("Access-Control-Expose-Headers", "observe");
      System.out.println("WebConfig Request Method: "+request.getMethod());
      if (!(request.getMethod().equalsIgnoreCase("OPTIONS"))) {
          System.out.println("Spiegel's WebConfig Chaining to ShowParameters");
          try {
              chain.doFilter(req, res);
          } catch(Exception e) {
              e.printStackTrace();
          }
      } else {
          System.out.println("Spiegel's WebConfig Pre-flight");
          response.setHeader("Access-Control-Allow-Methods", "POST,GET,DELETE,PUT");
          response.setHeader("Access-Control-Max-Age", "3600");
          response.setHeader("Access-Control-Allow-Headers", "Access-Control-Expose-Headers"+"Authorization, Access-Control-Allow-Origin, access-control-allow-origin, content-type,"+ "access-control-request-headers,access-control-request-method,accept,authorization,x-requested-with,responseType,observe");
          response.setHeader("Access-Control-Allow-Origin", "https://acad.kutztown.edu");
          response.setStatus(HttpServletResponse.SC_OK);
      }

    } 

    public void destroy() 
    {
    }

}
